-- MOAB example entity by Marine123


AddCSLuaFile('cl_init.lua')
AddCSLuaFile('shared.lua')
include('shared.lua')


local Model = "models/Combine_Helicopter/helicopter_bomb01.mdl" -- The model


function ENT:SpawnFunction(ply, tr) -- The spawn functions

	if not tr.Hit then return end
	
	local SpawnPos = tr.HitPos + tr.HitNormal*16
	local ent = ents.Create("sent_moabexample")
	ent:SetPos(SpawnPos)
	ent:SetVar("Owner",ply)
	ent:Spawn()
	ent:Activate()
	return ent
	
end



function ENT:Initialize()

	self.Entity:SetModel(Model)
	
	self.Entity:PhysicsInit(SOLID_VPHYSICS)
	self.Entity:SetMoveType(MOVETYPE_VPHYSICS)
	self.Entity:SetSolid(SOLID_VPHYSICS)
	
	local phys = self.Entity:GetPhysicsObject()
	if phys:IsValid() then
		phys:Wake()
	end
	
	undo.Create("MOAB example entity") -- Add the entity to the undo list
	undo.AddEntity(self.Entity)
	undo.SetPlayer(self.Entity:GetOwner())
	undo.Finish() 
	
	self.Explode = false
	
end



function ENT:PhysicsCollide( data, physobj ) -- Physical collisions

	if data.Speed > 500 and data.DeltaTime > 0.15 then -- If it hits an object at over 500 speed
        	self.Explode = true
			self.Entity:Break()
		end

end



function ENT:OnTakeDamage(dmginfo) -- Damage

	self.Explode = true
	self.Entity:Break()
	
	self.Entity:TakePhysicsDamage(dmginfo)
	
end



function ENT:Use(activator, caller) -- When someone tries to use the entity
	
	self.Explode = true
	self.Entity:Break()
	
end



function ENT:Break() -- The break function thats been called thrice now

	if not self.Explode then return end -- If self.Explode isn't set to True then skip this function

	ParticleExplode = ents.Create("info_particle_system")
	ParticleExplode:SetPos(self:GetPos())
	ParticleExplode:SetKeyValue("effect_name", "moab_blast") -- The names are cluster_explode, 40mm_explode, and agm_explode.
	ParticleExplode:SetKeyValue("start_active", "1")
	ParticleExplode:Spawn()
	ParticleExplode:Activate()
	ParticleExplode:Fire("kill", "", 30) -- Be sure to leave this at 30, or else the explosion may not be fully emitted.

	self.Entity:EmitSound("physics/glass/glass_bottle_break"..math.random(1, 2)..".wav")
	self.Entity:Remove()
	
end



function ENT:OnRemove() -- What should happen when the entity gets removed?
 -- Nothing, thats what
end



function ENT:Think()

end

